﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using $safeprojectname$.Properties;
using C1.Win.C1Ribbon;

namespace $safeprojectname$
{
    public partial class MainRibbonForm : C1RibbonForm
    {
        ThemeColor _themeColor = ThemeColor.Orange;
        ThemeLightness _themeLightness = ThemeLightness.LightGray;

        public MainRibbonForm()
        {
            InitializeComponent();

            RibbonStyle.UpdateInstance(_themeColor, _themeLightness);
        }

        void exitButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        void MainRibbonForm_Load(object sender, EventArgs e)
        {
            switch (c1Ribbon1.VisualStyle)
            {
                case VisualStyle.Custom:
                    customButton.Pressed = true;
                    break;
                case VisualStyle.Office2007Blue:
                    blue2007Button.Pressed = true;
                    break;
                case VisualStyle.Office2007Silver:
                    silver2007Button.Pressed = true;
                    break;
                case VisualStyle.Office2007Black:
                    black2007Button.Pressed = true;
                    break;
                case VisualStyle.Office2010Blue:
                    blue2010Button.Pressed = true;
                    break;
                case VisualStyle.Office2010Silver:
                    silver2010Button.Pressed = true;
                    break;
                case VisualStyle.Office2010Black:
                    black2010Button.Pressed = true;
                    break;
                case VisualStyle.Windows7:
                    windows7Button.Pressed = true;
                    break;
            }
            switch (_themeColor)
            {
                case ThemeColor.Azure:
                    azureButton.Pressed = true;
                    break;
                case ThemeColor.Blue:
                    blueButton.Pressed = true;
                    break;
                case ThemeColor.Green:
                    greenButton.Pressed = true;
                    break;
                case ThemeColor.Orange:
                    orangeButton.Pressed = true;
                    break;
                case ThemeColor.Orchid:
                    orchidButton.Pressed = true;
                    break;
                case ThemeColor.Red:
                    redButton.Pressed = true;
                    break;
                case ThemeColor.Teal:
                    tealButton.Pressed = true;
                    break;
                case ThemeColor.Violet:
                    violetButton.Pressed = true;
                    break;
            }
            switch (_themeLightness)
            {
                case ThemeLightness.DarkGray:
                    darkGrayButton.Pressed = true;
                    break;
                case ThemeLightness.LightGray:
                    lightGrayButton.Pressed = true;
                    break;
                case ThemeLightness.White:
                    whiteButton.Pressed = true;
                    break;
            }

            ctgColorSelector.SelectedIndex = 3;
        }

        void visualStyle_PressedButtonChanged(object sender, EventArgs e)
        {
            if (blue2007Button.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Office2007Blue;
            else if (silver2007Button.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Office2007Silver;
            else if (black2007Button.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Office2007Black;
            else if (blue2010Button.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Office2010Blue;
            else if (silver2010Button.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Office2010Silver;
            else if (black2010Button.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Office2010Black;
            else if (windows7Button.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Windows7;
            else if (customButton.Pressed)
                c1Ribbon1.VisualStyle = VisualStyle.Custom;
        }

        void themeColor_PressedButtonChanged(object sender, EventArgs e)
        {
            if (azureButton.Pressed)
                _themeColor = ThemeColor.Azure;
            else if (blueButton.Pressed)
                _themeColor = ThemeColor.Blue;
            else if (greenButton.Pressed)
                _themeColor = ThemeColor.Green;
            else if (orangeButton.Pressed)
                _themeColor = ThemeColor.Orange;
            else if (orchidButton.Pressed)
                _themeColor = ThemeColor.Orchid;
            else if (redButton.Pressed)
                _themeColor = ThemeColor.Red;
            else if (tealButton.Pressed)
                _themeColor = ThemeColor.Teal;
            else if (violetButton.Pressed)
                _themeColor = ThemeColor.Violet;

            RibbonStyle.UpdateInstance(_themeColor, _themeLightness);
        }

        void themeLightness_PressedButtonChanged(object sender, EventArgs e)
        {
            if (darkGrayButton.Pressed)
                _themeLightness = ThemeLightness.DarkGray;
            else if (lightGrayButton.Pressed)
                _themeLightness = ThemeLightness.LightGray;
            else if (whiteButton.Pressed)
                _themeLightness = ThemeLightness.White;

            RibbonStyle.UpdateInstance(_themeColor, _themeLightness);
        }

        void ctgColorSelector_ChangeCommitted(object sender, EventArgs e)
        {
            RibbonButton b = ctgColorSelector.SelectedItem as RibbonButton;
            if (b != null)
            {
                drawingToolsCTG.Color = (ContextualTabColor)Enum.Parse(typeof(ContextualTabColor), b.Text);
            }
        }

        void c1Ribbon1_MinimizedChanged(object sender, EventArgs e)
        {
            if (c1Ribbon1.Minimized)
            {
                minimizeRibbonButton.Visible = false;
                expandRibbonButton.Visible = true;
            }
            else
            {
                minimizeRibbonButton.Visible = true;
                expandRibbonButton.Visible = false;
            }
        }
        void minimizeRibbonButton_Click(object sender, EventArgs e)
        {
            c1Ribbon1.Minimized = true;
        }
        void expandRibbonButton_Click(object sender, EventArgs e)
        {
            c1Ribbon1.Minimized = false;
        }

        void rcListPinButton_Click(object sender, EventArgs e)
        {
            RibbonToggleButton pin = (RibbonToggleButton)sender;
            if (pin.Pressed)
                pin.SmallImage = Resources.Pinned;
            else
                pin.SmallImage = Resources.Unpinned;
        }

        void newWindowButton_Click(object sender, EventArgs e)
        {
            IsMdiContainer = true;
            ChildRibbonForm crf = new ChildRibbonForm();
            crf.MdiParent = this;
            crf.Text = String.Format("MDI Child Form {0:d}", MdiChildren.Length);
            crf.Show();
        }
        protected override void OnMdiChildActivate(EventArgs e)
        {
            base.OnMdiChildActivate(e);
            if (!WindowSwitching)
            {
                RefreshMdiWindowList(this, switchWindowsMenu);
            }
        }

        #region MDI Window Switching Code

        bool _windowSwitching;
        bool _turnOffMdi;

        internal bool WindowSwitching
        {
            get { return _windowSwitching; }
        }

        void RefreshMdiWindowList(Form parentForm, RibbonMenu menu)
        {
            RibbonItemCollection items = menu.Items;
            items.ClearAndDisposeItems();

            Form[] forms = parentForm.MdiChildren;
            Form activeChild = parentForm.ActiveMdiChild;
            int n = 1;
            for (int i = 0; i < forms.Length; i++)
            {
                Form f = forms[i];
                if (f != null && !f.Disposing && !f.IsDisposed)
                {
                    RibbonToggleButton tb = new RibbonToggleButton();
                    tb.Click += new EventHandler(activateWindow_Click);
                    tb.CanDepress = false;
                    tb.Pressed = object.ReferenceEquals(f, activeChild);
                    string text = f.Text;
                    if (n < 10)
                    {
                        text = "&" + n.ToString() + " " + text;
                        n++;
                    }
                    tb.Text = text;
                    tb.Tag = f;
                    tb.ToggleGroupName = "MdiChildren";
                    items.Add(tb);
                }
            }
            if (items.Count > 0)
                menu.Enabled = true;
            else
            {
                menu.Enabled = false;
                _turnOffMdi = true;
                Invalidate();
            }
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            if (_turnOffMdi)
            {
                IsMdiContainer = false;
                _turnOffMdi = false;
            }
        }

        void activateWindow_Click(object sender, EventArgs e)
        {
            RibbonToggleButton tb = sender as RibbonToggleButton;
            if (tb != null)
            {
                _windowSwitching = true;
                Form f = (Form)tb.Tag;
                f.Activate();
                if (f.WindowState == FormWindowState.Minimized)
                {
                    f.WindowState = FormWindowState.Normal;
                }
                _windowSwitching = false;
            }
        }

        #endregion

    }
}
